/*
 * Part of Very Secure FTPd
 * Licence: GPL v2
 * Author: Chris Evans
 * utility.c
 */

#include "utility.h"
#include "sysutil.h"
#include "str.h"
#include "defs.h"
#if  1				// '19.12.11 makabe  for debug
#include "logging.h"
#include "session.h"
extern struct vsf_share_mem *sh_ch_mem;
#endif

#define DIE_DEBUG
//#define XDS_DEBUG

#include <syslog.h>

void
die(const char* p_text)
{
  DLOG("fd = %d, ma = %d", sh_ch_mem->pd_data_handler, sh_ch_mem->xds_pd_access);		// '19.12.11 makabe  for SYSDJ-14345
#ifdef XDS_DEBUG
  syslog(LOG_ERR , "DIE.%s",p_text);
#endif
#ifdef DIE_DEBUG
  bug(p_text);
#endif
  vsf_sysutil_exit(1);
}

void
die2(const char* p_text1, const char* p_text2)
{
  struct mystr die_str = INIT_MYSTR;
  str_alloc_text(&die_str, p_text1);
  str_append_text(&die_str, p_text2);
  die(str_getbuf(&die_str));
}

void
bug(const char* p_text)
{
#ifdef XDS_DEBUG
  syslog(LOG_ERR , "BUG.%s",p_text);
#endif
  /* Rats. Try and write the reason to the network for diagnostics */
  vsf_sysutil_activate_noblock(VSFTP_COMMAND_FD);
  (void) vsf_sysutil_write_loop(VSFTP_COMMAND_FD, "500 OOPS: ", 10);
  (void) vsf_sysutil_write_loop(VSFTP_COMMAND_FD, p_text,
                                vsf_sysutil_strlen(p_text));
  (void) vsf_sysutil_write_loop(VSFTP_COMMAND_FD, "\r\n", 2);
  vsf_sysutil_exit(1);
}

void
vsf_exit(const char* p_text)
{
  (void) vsf_sysutil_write_loop(VSFTP_COMMAND_FD, p_text,
                                vsf_sysutil_strlen(p_text));
#ifdef XDS_DEBUG
  syslog(LOG_INFO , "EXIT CALL");
#endif
  vsf_sysutil_exit(0);
}

